unit ScribbleU;

//Variable form size
//Offscreen bitmap drawn once, tiled across form in OnPaint

interface

uses
  SysUtils, Types, Classes, QGraphics, QControls, QForms, QDialogs,
  QStdCtrls, QMenus, QTypes, QExtCtrls;

type
  TForm1 = class(TForm)
    MainMenu1: TMainMenu;
    Pen1: TMenuItem;
    Width1: TMenuItem;
    Color1: TMenuItem;
    dlgColor: TColorDialog;
    Narrow11: TMenuItem;
    Narrow31: TMenuItem;
    Average51: TMenuItem;
    Wide41: TMenuItem;
    Widest51: TMenuItem;
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure FormPaint(Sender: TObject);
    procedure FormMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure FormMouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure FormMouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure PenWidthClick(Sender: TObject);
    procedure Color1Click(Sender: TObject);
  private
    DrawingBmp: TBitmap;
    Drawing: Boolean;
    LastPos: TPoint;
  end;

var
  Form1: TForm1;

implementation

{$R *.xfm}

procedure TForm1.FormCreate(Sender: TObject);
begin
  DrawingBmp := TBitmap.Create;
  DrawingBmp.Width := Screen.Width;
  DrawingBmp.Height := Screen.Height;
  DrawingBmp.Canvas.Pen.Width := 1;
  DrawingBmp.Canvas.Pen.Color := clRed;
end;

procedure TForm1.FormDestroy(Sender: TObject);
begin
  DrawingBmp.Free
end;

procedure TForm1.FormPaint(Sender: TObject);
begin
  //Canvas.Draw(0, 0, DrawingBmp)
  //or
  Canvas.CopyRect(ClientRect, DrawingBmp.Canvas, ClientRect)
end;

procedure TForm1.FormMouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  if Button = mbLeft then
  begin
    Drawing := True;
    LastPos := Point(X, Y)
  end
end;

procedure TForm1.FormMouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  if Button = mbLeft then
    Drawing := False
end;

procedure TForm1.FormMouseMove(Sender: TObject; Shift: TShiftState; X,
  Y: Integer);
begin
  if Drawing then
  begin
    DrawingBmp.Canvas.MoveTo(LastPos.X, LastPos.Y);
    LastPos := Point(X, Y);
    DrawingBmp.Canvas.LineTo(LastPos.X, LastPos.Y);;
    Invalidate;
  end
end;

procedure TForm1.PenWidthClick(Sender: TObject);
begin
  with Sender as TMenuItem do
  begin
    DrawingBmp.Canvas.Pen.Width := Tag;
    Checked := True
  end
end;

procedure TForm1.Color1Click(Sender: TObject);
begin
  dlgColor.Color := DrawingBmp.Canvas.Pen.Color;
  if dlgColor.Execute then
    DrawingBmp.Canvas.Pen.Color := dlgColor.Color
end;

end.
