unit SimpleGraphics3U;

//Variable form size
//Offscreen bitmap drawn once, tiled across form in OnPaint

interface

uses
  SysUtils, Types, Classes, QGraphics, QControls, QForms, QDialogs,
  QStdCtrls;

type
  TForm1 = class(TForm)
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure FormPaint(Sender: TObject);
  private
    BkGrndBmp: TBitmap;
  end;

var
  Form1: TForm1;

implementation

{$R *.xfm}

uses
  UnionJack2;

procedure TForm1.FormCreate(Sender: TObject);
begin
  BkGrndBmp := TBitmap.Create;
  BkGrndBmp.Width := 200;
  BkGrndBmp.Height := 100;
  DrawUnionJack(BkGrndBmp.Canvas, Rect(0, 0, BkGrndBmp.Width, BkGrndBmp.Height));
end;

procedure TForm1.FormDestroy(Sender: TObject);
begin
  BkGrndBmp.Free;
end;

procedure TForm1.FormPaint(Sender: TObject);
var
  X, Y: Integer;
const
  XGap = 2;
  YGap = 2;
begin
  //Tile the Union Jack across the form
  Y := 0;
  while Y < ClientHeight do
  begin
    X := 0;
    while X < ClientWidth do
    begin
      Canvas.Draw(X, Y, BkGrndBmp);
      Inc(X, BkGrndBmp.Width + XGap);
    end;
    Inc(Y, BkGrndBmp.Height + YGap);
  end;
end;

end.
